//******************************************
//nQSQ7653_startup.c
//汾: V1.2 06/04/2020
//: ӳ
//ע:	
//******************************************
/*
 * --------------------------------------------------------------------------
 *   HEADER INCLUDE DEFINITIONS
 * --------------------------------------------------------------------------
 */
#include <stdlib.h>
#include "SQ7653_SFR.h"


/*
 * --------------------------------------------------------------------------
 *   MACRO DEFINITIONS
 * --------------------------------------------------------------------------
 */
 
extern unsigned int _BaseSP;				/*ѯBָʼַһ㶨xSRAMһַ*/
extern unsigned int _RAM_Top;				/*SRAMĵһַ*/
extern unsigned int _RAM_End;				/*SRAMһַ*/

extern unsigned char _TDataAddr[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned char _TDataOrg[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned int _TDataSize;				/* for tiny_data initialize, defined in link command file  */
extern unsigned char _NDataAddr[];			/* for near_data initialize, defined in link command file  */
extern unsigned char _NDataOrg[];			/* for near_data initialize, defined in link command file  */
extern unsigned int _NDataSize;				/* for near_data initialize, defined in link command file  */

/*
 * --------------------------------------------------------------------------
 *   FUNCTION DECLARATIONS
 * --------------------------------------------------------------------------
 */

/*#**************************************************************************#*/

/*
 ******************************************************************************
 * NAME				:STARTUP
 *-----------------------------------------------------------------------------
 * DESCRIPTION		:Startup routine
 * PARAMETER		:-
 *
 * RETURN VALUE		:-
 *
 ******************************************************************************
 */
void STARTUP( void )
{
	
	//CLKCR0 = 0x09;						// for SQ7653A PLL48M divide by 2, For Engineer Sample.
	CLKCR0 = 0x01;						    // for SQ7653A PLL24M divide by 1, For General.
//=============================================================================
//memory mapping
//=============================================================================
	DMCFG  = 0x02; 		
	//DMCFG  = 0x04;
    //DMCFG  = 0x00;	
	
//=============================================================================
//disable interrupt
//=============================================================================
	__DI();	//disable interrupt
	
//=============================================================================
//  Set CLKCR0	2019-06/12 JH ADD
//=============================================================================
//  ============================================
//  ϵyrԴxCLKCR0_SCKSRC                                 
//  ============================================
	
	CLKCR0_SCKSEL = 0x01;			// fsck = 24MHz	 (PLL) //Default
//	CLKCR0_SCKSEL = 0x02;			// fsck = 32KHz	 (LIRC) Ȳمr
//	CLKCR0_SCKSEL = 0x03;			// fsck = 16MHz	 (HXTAL)ⲿٕr
//	CLKCR0_SCKSEL = 0x06;			// fsck = 32768Hz(LXTAL)ⲿٕr

//  ============================================
//  ϵyrxCLKCR0_SCKLF                                 
//  ============================================
//	CLKCR0_SCKLF = 0;				// LIRC  Ȳ [AO]
//	CLKCR0_SCKLF = 1;				// LXTAL ⲿ

//  ============================================
//  ϵyrAlOãCLKCR0_SCKPSC                                 
//  ============================================
//	CLKCR0_SCKPSC = 0x00;			// fsysclk= fsck/1 * PLL֧Ԯ˹
//	CLKCR0_SCKPSC = 0x01;			// fsysclk= fsck/2 [AO]
//	CLKCR0_SCKPSC = 0x02;			// fsysclk= fsck/4
//	CLKCR0_SCKPSC = 0x03;			// fsysclk= fsck/8
//	CLKCR0_SCKPSC = 0x04;			// fsysclk= fsck/16
//	CLKCR0_SCKPSC = 0x05;			// fsysclk= fsck/32
//	CLKCR0_SCKPSC = 0x06;			// fsysclk= fsck/64
//	CLKCR0_SCKPSC = 0x07;			// fsysclk= fsck/128
	


//=============================================================================
//initial Registers
//=============================================================================
	__WA = 0x00;
	__BC = 0x00;
	__DE = 0x00;
	__HL = 0x00;
	__IX = 0x00;
	__IY = 0x00;

//=============================================================================
//initial Setting
//=============================================================================	
	__asm("CLR (0x08).5");

//=============================================================================
//initialize stack pointer
//=============================================================================
	__asm(" LD SP,__BaseSP");	//initialize stack pointer

//=============================================================================
//clear status word
//=============================================================================
	__asm(" LD PSW,0x00");

//=============================================================================
//clear RAM
//=============================================================================
	__asm(" LD HL,__RAM_Top");
	__asm(" LD BC,__RAM_End - __RAM_Top");	
	__asm(" LD A,0x00");
	__asm("CLR_RAM:");
	__asm(" LD (HL),A");
	__asm(" INC HL");
	__asm(" DEC BC");
	__asm(" JRS F,CLR_RAM");		/* Clear the RAM */

//=============================================================================
//initialize of tiny_data section
//=============================================================================
	__asm("	LD	IX,__TDataOrg");
	__asm("	LD	IY,__TDataAddr");
	__asm("	LD	A,__TDataSize");
	__asm("	DEC	A");
	__asm("	J	T,non_t_data");
	__asm("move_t_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	A");
	__asm("	J	F,move_t_data");
	__asm("non_t_data:");

//=============================================================================
//initialize of near_data section
//=============================================================================
	__asm("	LD	IX,__NDataOrg");
	__asm("	LD	IY,__NDataAddr");
	__asm("	LD	WA,__NDataSize");
	__asm("	DEC	WA");
	__asm("	J	T,non_n_data");
	__asm("move_n_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	WA");
	__asm("	J	F,move_n_data");
	__asm("non_n_data:");


//=============================================================================
//jump to main
//=============================================================================
	main();
	for (;;) {
		;
	}
}

