//*************************************************************************************
// 	: SQ7653_FMC.c
// 汾		: V1.0 2020/07/17A
// 		: FMC/EEPROM ʹú (FLASH/EEPROMƳ)
// ע		: FLASH/EEPROMغ㼯ڱӳ
//**************************************************************************************

#include "main.h"

// ============================================================================
// Flash 
// ============================================================================
//*********************************************************************
// 	: FMC_FERR_CLEAR()
// 	: Clear FSR 
// شֵ   : 
//*********************************************************************
void FMC_FERR_CLEAR()
{
	if(FSR_FERR !=0){
       FSR_FERR = 0x07;
       
	}
}



//*********************************************************************
// 	: FMC_Init()
// 	: Flash ʱӷƵ(FCKDIV)
// ע		: 
//            sysclk : System clock frequency in MHz
//*********************************************************************
void FMC_Init(unsigned char sysclk)
{
	FCKDIV = sysclk - 1;
}



//*********************************************************************
// 	: FMC_PageErase()
// 	: Flash ҳ
// شֵ   : 0: ɹ  
//            1: ʧ 
// ע		: 
//*********************************************************************
/*
//	1).ַдFADDRx
//	2).дƼĴָ
//	3).0xA50x5AдFDATA0
//	4).ȴɣæµ
//	5).شFlashѶ
*/

unsigned char FMC_PageErase(unsigned int address)
{
    unsigned char status;								// ״̬
    FMC_FERR_CLEAR();
    
	FADDR0 = (unsigned char)address & 0x00FF;			// 趨λַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;
	
	FCR = 0x18;											// ҳ

	FDATA0 = 0xA5;										// A5, 5A 
	FDATA0 = 0x5A;										// A5, 5A 
	
	do{	                                              	// ȴFLASHҳ
	    status = FSR;									
        status &= 0x80;
	//  status = FSR_BUSY;		
	}while(status);										// ״̬Ϊæµ(FSR_BUSY=1)

	return(FSR_FERR);									// شFlashѶ
}



//*********************************************************************
// 	: FMC_WriteByte()
// 	: ָλַдһByte
// شֵ   : 0:дɹ  
//            1:дʧ<дԤֵͬ>  
// ע		: 
//*********************************************************************
/*
//	1).ʼַдFADDRx
//	2).дFDATAx
//	3).дƼĴָ
//	4).0xA50x5AдFDATA0
//	5).ȴ(æµ)
//	6).شFlashѶ
*/

unsigned char FMC_WriteByte(unsigned int address, unsigned char data)
{
	unsigned char status;								// ״̬
	FMC_FERR_CLEAR();
    
	FDATA0 = data;                                      // дݼĴ  
	
	FADDR0 = (unsigned char)address & 0x00FF;        	// 趨λַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;

	FCR = 0x04;                                  		// д 
	FDATA0 = 0xA5;                                     	// A5, 5A 
	FDATA0 = 0x5A;                                     	// A5, 5A 
	
	do{                                                	// ȴFLASHд빤
	    status = FSR;
        status &= 0x80;
	// status = FSR_BUSY;		
	}while(status);										// ״̬Ϊæµ(FSR_BUSY=1)
	
	return(FSR_FERR);									// شFlashѶ
}



//*********************************************************************
// 	: FMC_ReadByte()
// 	: ָλַһByte
// ע		: 
//*********************************************************************
/*
//	1).ʼַдFADDRx
//	2).дƼĴָ
//	3).ȴɣæµ
//	4).
//	5).FDATAxȡ
*/


void FMC_ReadByte(unsigned int address, unsigned char* data)
{
    FMC_FERR_CLEAR();
	FADDR0 = (unsigned char)address & 0x00FF;         	// 趨λַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;
   
    FCR = 0x00;                                   		// ݶȡ        
	*data = FDATA0; 
}



// ============================================================================
// EEPROM 
// ============================================================================
//*********************************************************************
// 	: FMC_EEERR_CLEAR()
// 	: Clear ESR 
// شֵ   : 
//*********************************************************************
void FMC_EEERR_CLEAR()
{
	if(EESR_EEERR !=0){
       EESR_EEERR = 0x07;
       
	}
}


//*********************************************************************
// 	: FMC_PageEraseEE()
// 	: EEPROM ҳ
// شֵ   : 0:ɹ  
//            1:ʧ 
// ע		: 
//*********************************************************************
unsigned char FMC_PageEraseEE(unsigned int address)
{
    unsigned char status;								// ״̬
	FMC_EEERR_CLEAR();
    
	EEADDR0 = (unsigned char)address & 0x00FF;			// 趨λַĴ
	EEADDR1 = (unsigned char)(address >> 8) & 0x00FF;
	
	EECR = 0x18;										// 퓲
	EEDATA0 = 0xA5;                                    	// A5, 5A 
	EEDATA0 = 0x5A;                                    	// A5, 5A 
	
	do{	                                               	// ȴEEPROMҳ
	    status = EESR;
        status &= 0x80; 		  
	}while(status);										// ״̬Ϊæµ(EESR_BUSY=1)

	return(EESR_EEERR);									// شEEPROMѶ
}



//*********************************************************************
// 	: FMC_WriteByteEE()
// 	: ָλַдһByte
// شֵ    : 0:дɹ  
//             1:дʧ<дԤֵͬ>  
// ע		: 
//*********************************************************************
unsigned char FMC_WriteByteEE(unsigned int address, unsigned char data)
{
	unsigned char status;								// ״̬
    FMC_EEERR_CLEAR();
    
	EEDATA0 = data;                                     // дݼĴ 
	
	EEADDR0 = (unsigned char)address & 0x00FF;        	// 趨λַĴ
	EEADDR1 = (unsigned char)(address >> 8) & 0x00FF;

	EECR = 0x04;                                  		// д  
	EEDATA0 = 0xA5;                                     // A5, 5A 
	EEDATA0 = 0x5A;                                     // A5, 5A 
	
	do{                                                	// ȴEEPROMд빤
	    status = EESR;
        status &= 0x80; 		  
	}while(status);										// ״̬Ϊæµ(EESR_BUSY=1)
	
	return(EESR_EEERR);									// شEEPROMѶ
}



//*********************************************************************
// 	: FMC_ReadByteEE()
// 	: ָλַһByte
// ע		: 
//*********************************************************************
void FMC_ReadByteEE(unsigned int address, unsigned char* data)
{
    FMC_EEERR_CLEAR();
	EEADDR0 = (unsigned char)address & 0x00FF;       	// 趨λַĴ
	EEADDR1 = (unsigned char)(address >> 8) & 0x00FF;
   
    EECR = 0x00;                                   		// ݶȡ       
	*data = EEDATA0; 
}


