//*************************************************************************************
// 	: SQ7653_I2C.c
// 汾		: V1.1 (Sep. 4, 20)
// 		: I2C0 ʹú (I2C0Ƴ)
// ע		: I2C0 غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char errCode = 0x00;
unsigned char tWait = 0;
unsigned char addrDirection;

//*********************************************************************
// 	: I2C0_SetSlaveAddr()
// 	: ôģʽַ
// ֵ	: none
// شֵ	: none
//
// ע		:
//*********************************************************************
void I2C0_SetSlaveAddr(uchar addr){
	I2C0AR = addr & 0xfe;				// I2C0AR[7:1]: Slave address setting
										// 0Xfe	1111 1110		
										// &0xfe   : and clear bit0  
}



//*********************************************************************
// 	: I2C0_Init()
// 	: I2C0ʼ
// ֵ	: none
// شֵ	: none
//
// ע		: I2C0 ùܽšģʽKI2C		  
//*********************************************************************
void I2C0_Init(){

    //====== I2C0ܽųʼ ======
    /* Tips: SQ7653 ʹPxDIȡܽŵƽ趨PNIC (PxCFGCR)֮ǰʹ */
    
        while(P0DI_P7!=1 || P0DI_P6 !=1){   // ȷSDA0 (P0.7) ; SCL0 (P0.6)Ϊߵλ
            CLR_WDT;						// Źʱ (ι)
            errCode = initBusLowErr;
			I2C0_Error_Handling();          // 
            
        }	
	
      //  SDA0 (P0.7) ; SCL0 (P0.6)-------
      
        P0CFGCR = 0xF3;  				    // P0.7趨ΪSDA0	1 111 0011
        P0CFGCR = 0xE3;					    // P0.6趨ΪSCL0	1 110 0011

    //====== ܿ(Enable) ======
        PCKEN2_I2C0 = 1;                    // ȿݴò,I2C0 Enable
        

        SBI0CR2_SBIM = 1;                   // ѡΪ߽ӿģʽ
    
    //====== 趨 ======
        //SBI0CR1 = 0x16; 

        SBI0CR1_ACK = 1;                    // Ӧģʽ(ACK enable)        
        SBI0CR1_BC  = BC_8bit;              // (λ)9bit = 8bit + 1bit(ACK)
        SBI0CR1_SCK = SCK_HI_135_LO_138;    // ģʽƵʿ @fsysclk=24MHzfsclԼΪ88 kHz
      
        // SBI0CR2<MST> <TRX><BB>Ϊ0, <PIN>Ϊ1,<SWRST>Ϊ00,ڴģʽжĬֵ
        SBI0CR2 = 0x18;						// 0001 1000

}




//SBI0CR2--------------------------------------------------------------- 
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//----------------------------------------------------------------------  


//*********************************************************************
// 	: I2C0_Int()
// 	: /ֹ I2C0ж
// ֵ	: - config : enable  I2C0ж
//                     : disable ֹI2C0ж
// شֵ	: none
//
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_Int(uchar config){
	__asm("DI");						// ֹпж
	
	IFR_I2C0_IRQ = 0;                   // ж
	IER_I2C0_IRQ = config;	            // config = enable  ,I2C0ж
                                        // config = disable ,I2C0жϽֹ
	
	__asm("EI");						// пж
}


//*********************************************************************
// 	: I2C0_Start()
// 	: ʼ趨Ҫʼд/(ȡ)֮ʼλַ
// ֵ	: - deviceId  : 趨 Slave Device ID (Slave addr)
//                          e.g. AT24C08Ϊ(0xa0)
//            - addr      : 趨 ʼд/(ȡ)Slave֮ʼλַ
// شֵ	: errCode
//
// ע		: 
//*********************************************************************
uchar I2C0_Start(uchar deviceId, uchar addr){
	
	while(SBI0SR_BB == 1){
    }                                   // ȷ״̬Ϊ״̬ 0: free ; 1 :busy

	SBI0CR1_ACK = 1;                    // *** SBI0CR1<ACK>趨,ڴ֮ǰ ***
 
    I2C0_SetSlaveAddr_Direction(deviceId, directionW); // ôװõַ뷽
	
    SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
                                        // Set master,,ʼ,ȡжϷ and ģʽ
	
 	I2C0_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
	I2C0_Wait_Slave_ACK();              // ȴSlaveشACK

    NOP;
    
    //---------------------------------------------------------------------------------------------    
	
    if(errCode != 0)  return errCode;
  
	SBI0DBR = addr;					    // 趨Ҫʼд/(ȡ)֮ʼλַ
	SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
                                        
    I2C0_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
    I2C0_Wait_Slave_ACK();              // ȴSlaveشACK

    NOP;
}


//*********************************************************************
// 	: I2C0_Confirm_Tx_Completed()
// 	: ȴbyteɣȷPINǷΪ0
// ֵ	: none
// شֵ	: none
// 
// ע		:
//*********************************************************************
void I2C0_Confirm_Tx_Completed(){
   	while(SBI0SR_PIN)                   // ȴbyte, PINΪ0	
	{
    }			                         
  

}



//*********************************************************************
// 	: I2C0_Wait_Slave_ACK()
// 	: ȴSlaveشACK
// ֵ	: none
// شֵ	: - errCode
//
// ע		:
//*********************************************************************
uchar I2C0_Wait_Slave_ACK(){
    uchar tWait;
    errCode = 0x00;
	tWait = 0;

    while(SBI0SR_LRB == 1){			    // check <LRB> յλ, ӻӦźACK								
            tWait++;					    // Ӧ,  ==> SCKᱣ
                
            if(tWait>waitCountMax){	        // Ӧѭ		
                I2C0_Stop();			    // I2C0 stop -> release SCK
				errCode = nackTimeoutErr;
 				break;
            }
	NOP;
    }
	
	NOP;
	if(errCode != 0)  return errCode;
	
    // ACK
    errCode = 0x00;                    // error, errorCode = 0x00
    return errCode;
 
}


//*********************************************************************
// 	: I2C0_SetSlaveAddr_Direction() 
// 	: ôװõַ뷽
// ֵ	: - deviceId     : 趨 Slave Device ID (Slave addr)
//            - i2cDirection :  directionW (ҪдݵSlave)
//                              directionR (ҪSlave)
// شֵ	: errCode
//
// ע		: 
//*********************************************************************
void I2C0_SetSlaveAddr_Direction(uchar deviceId, uchar i2cDirection){

    addrDirection = (deviceId | i2cDirection);
	SBI0DBR = addrDirection;

}


//*********************************************************************
// 	: I2C0_ReStart()
// 	: I2C0 ReStart
// ֵ	: none
// شֵ	: none
//
// ע		: һڱװװüݴ䷽
//            Master modeʹ
//*********************************************************************
uchar I2C0_ReStart(uchar deviceId){

	SBI0CR2 = 0x18;						// 0001 1000
										// Set master,,ʼ,ȡжϷ and ģʽ

	while(SBI0SR_BB){                  // ȷ״̬Ϊ״̬ 0: free ; 1 :busy
    }	  
	while(SBI0SR_LRB == 0){}
    
    I2C0_SetSlaveAddr_Direction(deviceId, directionR); // ôװõַ뷽
	SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
                                        
    I2C0_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
    I2C0_Wait_Slave_ACK();              // ȴSlaveشACK
    return errCode;
}



//*********************************************************************
// 	: I2C0_Stop()
// 	: ֹͣ
// ֵ	: none
// شֵ	: none
//
// ע		: 
//            Master modeʹ
//*********************************************************************
void I2C0_Stop(void){
	SBI0CR2 = 0xd8;						// Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
										// 1101 1000
										// Set master,,ֹͣ,ȡжϷ and Portģʽ
										
	while(SBI0SR_BB == 1){}			    // ȷ״̬Ϊ״̬ 0: free ; 1 :busy
}





//*********************************************************************
// 	: I2C0_Bytes_Write() 
// 	: д(byte write * len)
// ֵ	: 
//            - *data   :д
//            - len     :дϳ
// شֵ	: errCode
//
// ע		:  
//            Master modeʹ
//*********************************************************************
uchar I2C0_Bytes_Write(uchar *data, uchar len){
	uchar i;

	if(errCode != 0)  return errCode;
    
	for(i=0; i<len; i++){	
		tWait = 0;
		SBI0DBR = *data;
		data++;
        
        I2C0_Confirm_Tx_Completed();     // ȴbyteɣȷPINǷΪ0
        I2C0_Wait_Slave_ACK();	         // ȴSlaveشACK
	}
    return errCode;
}



//*********************************************************************
// 	: I2C0_Bytes_Read() 
// 	: նȡ (byte read * len)
// ֵ	: - addr    :ʼȡʼλַ
//            - *data   :ȡ
//            - len     :ȡϳ
// شֵ	: errCode
//
// ע		:  
//            Master modeʹ
//*********************************************************************
uchar I2C0_Bytes_Read(uchar *data, uchar len){
	uchar i;
    if(I2C0_Wait_Slave_ACK()!= 0x00){
       return errCode;

    }
    
    NOP;
	len -= 1;
    // (len-1)byte..................
	for(i=0; i<len; i++){
		SBI0DBR   = 0x00;				// write dummy data to set PIN = 1
		I2C0_Confirm_Tx_Completed();
		*data = SBI0DBR;
		data++;
	}

    // һbyte..................
	SBI0CR1_ACK = 0;					// ACK=0
	SBI0DBR     = 0x00;					// write dummy data to set PIN = 1
	I2C0_Confirm_Tx_Completed();
	*data = SBI0DBR;

    //	Termination of data transfer by master mode
    //	Sent 1 bit negative acknowledge............
	SBI0CR1_BC = 1;						// BC, bit count = 1
	SBI0DBR    = 0x00;					// write dummy data to set PIN = 1
	I2C0_Confirm_Tx_Completed();
}



//*********************************************************************
// 	: I2C0_Reset()
// 	: λ
// ֵ	: none
// شֵ	: none
// 
// ע		: SBI0CR1,I2C0AR,SBI0CR2 ,SBI0CR2<SBIM>
//*********************************************************************
void I2C0_Reset(){
	SBI0CR2 = 0x1A;						// дSWRST[1:0] = 0x02
	SBI0CR2 = 0x19;						// дSWRST[1:0] = 0x01

}



//*********************************************************************
// 	: I2C0_IRQ()
// 	: I2C0жӳ
// ע		:
//*********************************************************************
void __interrupt I2C0_IRQ(void){
    __asm("NOP");                         // ָ

}


//*********************************************************************
// 	: I2C0_Error_Handling() 
// 	: 
// ֵ	: none
// شֵ	: none
// 
// ע		: I2C0ʼʱ߽ӿڽλSDASCLûнΪߵλ
//            
//*********************************************************************
void I2C0_Error_Handling(){
	if (errCode == initBusLowErr){
	
	//Add your error handling ......
		while(1){
			CLR_WDT;					 // Źʱ (ι)
			__asm("NOP");
		}
    }

}



